#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_SquamaDragonSlayerCFG.h"
std::auto_ptr<Fish_SquamaDragonSlayerCFG> Fish_SquamaDragonSlayerCFG::msSingleton(nullptr);

int Fish_SquamaDragonSlayerCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SquamaDragonSlayerCFGData* Fish_SquamaDragonSlayerCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_SquamaDragonSlayerCFGData>& Fish_SquamaDragonSlayerCFG::GetMapData()
{
	return mMapData;
}

void Fish_SquamaDragonSlayerCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_SquamaDragonSlayerCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SquamaDragonSlayerCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mItemId = element->IntAttribute("ItemId");
		data.mItemCount = element->IntAttribute("ItemCount");
		data.mDimensityCount = element->IntAttribute("DimensityCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_SquamaDragonSlayerCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SquamaDragonSlayerCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_SquamaDragonSlayerCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_SquamaDragonSlayerCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_SquamaDragonSlayerCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readInt(L, "ItemCount", data.mItemCount);
		LuaCfgHelper::readInt(L, "DimensityCount", data.mDimensityCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_SquamaDragonSlayerCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_SquamaDragonSlayerCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_SquamaDragonSlayerCFG* Fish_SquamaDragonSlayerCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SquamaDragonSlayerCFG());
	}
	return msSingleton.get();
}

void Fish_SquamaDragonSlayerCFG::Release()
{
	msSingleton.reset(nullptr);
}
